VTK: vtkImageConvolve Class Reference

| VTK 9.3.1

Public Member Functions | Protected Member Functions | Protected Attributes | List of all members
vtkImageConvolve Class Reference

Convolution of an image with a kernel. More...

`#include <vtkImageConvolve.h>`

Inheritance diagram for vtkImageConvolve:
[legend]
Collaboration diagram for vtkImageConvolve:
[legend]

## Public Member Functions
void | SetKernel7x7 (const double kernel[49])
double * | GetKernel7x7 ()
void | GetKernel7x7 (double kernel[49])
void | SetKernel3x3x3 (const double kernel[27])
| Set the kernel to be a 3x3x3 or 5x5x5 or 7x7x7 kernel. More...
void | SetKernel5x5x5 (const double kernel[125])
void | SetKernel7x7x7 (const double kernel[343])
double * | GetKernel5x5x5 ()
void | GetKernel5x5x5 (double kernel[125])
double * | GetKernel7x7x7 ()
void | GetKernel7x7x7 (double kernel[343])
virtual int * | GetKernelSize ()
| Get the kernel size. More...
virtual void | GetKernelSize (int &, int &, int &)
| Get the kernel size. More...
virtual void | GetKernelSize (int[3])
| Get the kernel size. More...
void | SetKernel3x3 (const double kernel[9])
| Set the kernel to be a given 3x3 or 5x5 or 7x7 kernel. More...
void | SetKernel5x5 (const double kernel[25])
| Set the kernel to be a given 3x3 or 5x5 or 7x7 kernel. More...
double * | GetKernel3x3 ()
| Return an array that contains the kernel. More...
void | GetKernel3x3 (double kernel[9])
| Return an array that contains the kernel. More...
double * | GetKernel5x5 ()
| Return an array that contains the kernel. More...
void | GetKernel5x5 (double kernel[25])
| Return an array that contains the kernel. More...
double * | GetKernel3x3x3 ()
| Return an array that contains the kernel. More...
void | GetKernel3x3x3 (double kernel[27])
| Return an array that contains the kernel. More...
Public Member Functions inherited from vtkThreadedImageAlgorithm
vtkThreadedImageAlgorithm * | NewInstance () const
virtual void | ThreadedExecute (vtkImageData *inData, vtkImageData *outData, int extent[6], int threadId)
virtual int | SplitExtent (int splitExt[6], int startExt[6], int num, int total)
| Putting this here until I merge graphics and imaging streaming. More...
virtual bool | GetEnableSMP ()
| Enable/Disable SMP for threading. More...
virtual void | SetEnableSMP (bool)
| Enable/Disable SMP for threading. More...
virtual void | SetMinimumPieceSize (int, int, int)
| The minimum piece size when volume is split for execution. More...
virtual void | SetMinimumPieceSize (int[3])
| The minimum piece size when volume is split for execution. More...
virtual int * | GetMinimumPieceSize ()
| The minimum piece size when volume is split for execution. More...
virtual void | GetMinimumPieceSize (int &, int &, int &)
| The minimum piece size when volume is split for execution. More...
virtual void | GetMinimumPieceSize (int[3])
| The minimum piece size when volume is split for execution. More...
virtual void | SetDesiredBytesPerPiece (vtkIdType)
| The desired bytes per piece when volume is split for execution. More...
virtual vtkIdType | GetDesiredBytesPerPiece ()
| The desired bytes per piece when volume is split for execution. More...
virtual void | SetSplitMode (int)
| Set the method used to divide the volume into pieces. More...
void | SetSplitModeToSlab ()
| Set the method used to divide the volume into pieces. More...
void | SetSplitModeToBeam ()
| Set the method used to divide the volume into pieces. More...
void | SetSplitModeToBlock ()
| Set the method used to divide the volume into pieces. More...
virtual int | GetSplitMode ()
| Set the method used to divide the volume into pieces. More...
virtual void | SetNumberOfThreads (int)
| Get/Set the number of threads to create when rendering. More...
virtual int | GetNumberOfThreads ()
| Get/Set the number of threads to create when rendering. More...
Public Member Functions inherited from vtkImageAlgorithm
vtkImageAlgorithm * | NewInstance () const
vtkTypeBool | ProcessRequest (vtkInformation *, vtkInformationVector **, vtkInformationVector *) override
| Process a request from the executive. More...
vtkImageData * | GetOutput ()
| Get the output data object for a port on this algorithm. More...
vtkImageData * | GetOutput (int)
| Get the output data object for a port on this algorithm. More...
virtual void | SetOutput (vtkDataObject *d)
| Get the output data object for a port on this algorithm. More...
void | SetInputData (vtkDataObject *)
| Assign a data object as input. More...
void | SetInputData (int, vtkDataObject *)
| Assign a data object as input. More...
vtkDataObject * | GetInput (int port)
| Get a data object for one of the input port connections. More...
vtkDataObject * | GetInput ()
| Get a data object for one of the input port connections. More...
vtkImageData * | GetImageDataInput (int port)
| Get a data object for one of the input port connections. More...
virtual void | AddInputData (vtkDataObject *)
| Assign a data object as input. More...
virtual void | AddInputData (int, vtkDataObject *)
| Assign a data object as input. More...
Public Member Functions inherited from vtkAlgorithm
vtkAlgorithm * | NewInstance () const
vtkTypeBool | HasExecutive ()
| Check whether this algorithm has an assigned executive. More...
vtkExecutive * | GetExecutive ()
| Get this algorithm's executive. More...
virtual void | SetExecutive (vtkExecutive *executive)
| Set this algorithm's executive. More...
vtkTypeBool | ProcessRequest (vtkInformation *request, vtkCollection *inInfo, vtkInformationVector *outInfo)
| Version of ProcessRequest() that is wrapped. More...
virtual int | ComputePipelineMTime (vtkInformation *request, vtkInformationVector **inInfoVec, vtkInformationVector *outInfoVec, int requestFromOutputPort, vtkMTimeType *mtime)
| A special version of ProcessRequest meant specifically for the pipeline modified time request. More...
virtual int | ModifyRequest (vtkInformation *request, int when)
| This method gives the algorithm a chance to modify the contents of a request before or after (specified in the when argument) it is forwarded. More...
vtkInformation * | GetInputPortInformation (int port)
| Get the information object associated with an input port. More...
vtkInformation * | GetOutputPortInformation (int port)
| Get the information object associated with an output port. More...
int | GetNumberOfInputPorts ()
| Get the number of input ports used by the algorithm. More...
int | GetNumberOfOutputPorts ()
| Get the number of output ports provided by the algorithm. More...
void | SetAbortExecuteAndUpdateTime ()
| Set AbortExecute Flag and update LastAbortTime. More...
void | UpdateProgress (double amount)
| Update the progress of the process object. More...
bool | CheckAbort ()
| Checks to see if this filter should abort. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, const char *fieldAssociation, const char *attributeTypeorName)
| String based versions of SetInputArrayToProcess(). More...
vtkInformation * | GetInputArrayInformation (int idx)
| Get the info object for the specified input array to this algorithm. More...
void | RemoveAllInputs ()
| Remove all the input data. More...
vtkDataObject * | GetOutputDataObject (int port)
| Get the data object that will contain the algorithm output for the given port. More...
vtkDataObject * | GetInputDataObject (int port, int connection)
| Get the data object that will contain the algorithm input for the given port and given connection. More...
virtual void | RemoveInputConnection (int port, vtkAlgorithmOutput *input)
| Remove a connection from the given input port index. More...
virtual void | RemoveInputConnection (int port, int idx)
| Remove a connection given by index idx. More...
virtual void | RemoveAllInputConnections (int port)
| Removes all input connections. More...
virtual void | SetInputDataObject (int port, vtkDataObject *data)
| Sets the data-object as an input on the given port index. More...
virtual void | SetInputDataObject (vtkDataObject *data)
virtual void | AddInputDataObject (int port, vtkDataObject *data)
| Add the data-object as an input to this given port. More...
virtual void | AddInputDataObject (vtkDataObject *data)
vtkAlgorithmOutput * | GetOutputPort (int index)
| Get a proxy object corresponding to the given output port of this algorithm. More...
vtkAlgorithmOutput * | GetOutputPort ()
int | GetNumberOfInputConnections (int port)
| Get the number of inputs currently connected to a port. More...
int | GetTotalNumberOfInputConnections ()
| Get the total number of inputs for this algorithm. More...
vtkAlgorithmOutput * | GetInputConnection (int port, int index)
| Get the algorithm output port connected to an input port. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index, int &algPort)
| Returns the algorithm and the output port index of that algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm (int port, int index)
| Returns the algorithm connected to a port-index pair. More...
vtkAlgorithm * | GetInputAlgorithm ()
| Equivalent to GetInputAlgorithm(0, 0). More...
vtkExecutive * | GetInputExecutive (int port, int index)
| Returns the executive associated with a particular input connection. More...
vtkExecutive * | GetInputExecutive ()
| Equivalent to GetInputExecutive(0, 0) More...
vtkInformation * | GetInputInformation (int port, int index)
| Return the information object that is associated with a particular input connection. More...
vtkInformation * | GetInputInformation ()
| Equivalent to GetInputInformation(0, 0) More...
vtkInformation * | GetOutputInformation (int port)
| Return the information object that is associated with a particular output port. More...
virtual vtkTypeBool | Update (int port, vtkInformationVector *requests)
| This method enables the passing of data requests to the algorithm to be used during execution (in addition to bringing a particular port up-to-date). More...
virtual vtkTypeBool | Update (vtkInformation *requests)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdatePiece (int piece, int numPieces, int ghostLevels, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateExtent (const int extents[6])
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual int | UpdateTimeStep (double time, int piece=-1, int numPieces=1, int ghostLevels=0, const int extents[6]=nullptr)
| Convenience method to update an algorithm after passing requests to its first output port. More...
virtual void | UpdateInformation ()
| Bring the algorithm's information up-to-date. More...
virtual void | UpdateDataObject ()
| Create output object(s). More...
virtual void | PropagateUpdateExtent ()
| Propagate meta-data upstream. More...
virtual void | UpdateWholeExtent ()
| Bring this algorithm's outputs up-to-date. More...
void | ConvertTotalInputToPortConnection (int ind, int &port, int &conn)
| Convenience routine to convert from a linear ordering of input connections to a port/connection pair. More...
virtual vtkInformation * | GetInformation ()
| Set/Get the information object associated with this algorithm. More...
virtual void | SetInformation (vtkInformation *)
| Set/Get the information object associated with this algorithm. More...
bool | UsesGarbageCollector () const override
| Participate in garbage collection. More...
virtual void | SetAbortExecute (vtkTypeBool)
| Set/Get the AbortExecute flag for the process object. More...
virtual vtkTypeBool | GetAbortExecute ()
| Set/Get the AbortExecute flag for the process object. More...
virtual void | AbortExecuteOn ()
| Set/Get the AbortExecute flag for the process object. More...
virtual void | AbortExecuteOff ()
| Set/Get the AbortExecute flag for the process object. More...
virtual double | GetProgress ()
| Get the execution progress of a process object. More...
void | SetContainerAlgorithm (vtkAlgorithm *containerAlg)
| Set/get a Container algorithm for this algorithm. More...
vtkAlgorithm * | GetContainerAlgorithm ()
| Set/get a Container algorithm for this algorithm. More...
virtual void | SetAbortOutput (bool)
| Set/Get an internal variable used to communicate between the algorithm and executive. More...
virtual bool | GetAbortOutput ()
| Set/Get an internal variable used to communicate between the algorithm and executive. More...
void | SetProgressShiftScale (double shift, double scale)
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
virtual double | GetProgressShift ()
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
virtual double | GetProgressScale ()
| Specify the shift and scale values to use to apply to the progress amount when `UpdateProgress` is called. More...
void | SetProgressText (const char *ptext)
| Set the current text message associated with the progress state. More...
virtual char * | GetProgressText ()
| Set the current text message associated with the progress state. More...
virtual unsigned long | GetErrorCode ()
| The error code contains a possible error that occurred while reading or writing the file. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, const char *name)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputArrayToProcess (int idx, int port, int connection, int fieldAssociation, int fieldAttributeType)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputArrayToProcess (int idx, vtkInformation *info)
| Set the input data arrays that this algorithm will process. More...
virtual void | SetInputConnection (int port, vtkAlgorithmOutput *input)
| Set the connection for the given input port index. More...
virtual void | SetInputConnection (vtkAlgorithmOutput *input)
| Set the connection for the given input port index. More...
virtual void | AddInputConnection (int port, vtkAlgorithmOutput *input)
| Add a connection to the given input port index. More...
virtual void | AddInputConnection (vtkAlgorithmOutput *input)
| Add a connection to the given input port index. More...
virtual void | Update (int port)
| Bring this algorithm's outputs up-to-date. More...
virtual void | Update ()
| Bring this algorithm's outputs up-to-date. More...
virtual void | SetReleaseDataFlag (vtkTypeBool)
| Turn release data flag on or off for all output ports. More...
virtual vtkTypeBool | GetReleaseDataFlag ()
| Turn release data flag on or off for all output ports. More...
void | ReleaseDataFlagOn ()
| Turn release data flag on or off for all output ports. More...
void | ReleaseDataFlagOff ()
| Turn release data flag on or off for all output ports. More...
int | UpdateExtentIsEmpty (vtkInformation *pinfo, vtkDataObject *output)
| This detects when the UpdateExtent will generate no data This condition is satisfied when the UpdateExtent has zero volume (0,-1,...) or the UpdateNumberOfPieces is 0. More...
int | UpdateExtentIsEmpty (vtkInformation *pinfo, int extentType)
| This detects when the UpdateExtent will generate no data This condition is satisfied when the UpdateExtent has zero volume (0,-1,...) or the UpdateNumberOfPieces is 0. More...
int * | GetUpdateExtent ()
| These functions return the update extent for output ports that use 3D extents. More...
int * | GetUpdateExtent (int port)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int port, int &x0, int &x1, int &y0, int &y1, int &z0, int &z1)
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int extent[6])
| These functions return the update extent for output ports that use 3D extents. More...
void | GetUpdateExtent (int port, int extent[6])
| These functions return the update extent for output ports that use 3D extents. More...
int | GetUpdatePiece ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdatePiece (int port)
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateNumberOfPieces ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateNumberOfPieces (int port)
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateGhostLevel ()
| These functions return the update extent for output ports that use piece extents. More...
int | GetUpdateGhostLevel (int port)
| These functions return the update extent for output ports that use piece extents. More...
void | SetProgressObserver (vtkProgressObserver *)
| If an ProgressObserver is set, the algorithm will report progress through it rather than directly. More...
virtual vtkProgressObserver * | GetProgressObserver ()
| If an ProgressObserver is set, the algorithm will report progress through it rather than directly. More...
Public Member Functions inherited from vtkObject
| vtkBaseTypeMacro (vtkObject, vtkObjectBase)
virtual void | DebugOn ()
| Turn debugging output on. More...
virtual void | DebugOff ()
| Turn debugging output off. More...
bool | GetDebug ()
| Get the value of the debug flag. More...
void | SetDebug (bool debugFlag)
| Set the value of the debug flag. More...
virtual void | Modified ()
| Update the modification time for this object. More...
virtual vtkMTimeType | GetMTime ()
| Return this object's modified time. More...
void | RemoveObserver (unsigned long tag)
void | RemoveObservers (unsigned long event)
void | RemoveObservers (const char *event)
void | RemoveAllObservers ()
vtkTypeBool | HasObserver (unsigned long event)
vtkTypeBool | HasObserver (const char *event)
vtkTypeBool | InvokeEvent (unsigned long event)
vtkTypeBool | InvokeEvent (const char *event)
std::string | GetObjectDescription () const override
| The object description printed in messages and PrintSelf output. More...
unsigned long | AddObserver (unsigned long event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
unsigned long | AddObserver (const char *event, vtkCommand *, float priority=0.0f)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkCommand * | GetCommand (unsigned long tag)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObserver (vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
void | RemoveObservers (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (unsigned long event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
vtkTypeBool | HasObserver (const char *event, vtkCommand *)
| Allow people to add/remove/invoke observers (callbacks) to any VTK object. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, void(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Overloads to AddObserver that allow developers to add class member functions as callbacks for events. More...
template<class U , class T >
unsigned long | AddObserver (unsigned long event, U observer, bool(T::*callback)(vtkObject *, unsigned long, void *), float priority=0.0f)
| Allow user to set the AbortFlagOn() with the return value of the callback method. More...
vtkTypeBool | InvokeEvent (unsigned long event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
vtkTypeBool | InvokeEvent (const char *event, void *callData)
| This method invokes an event and return whether the event was aborted or not. More...
virtual void | SetObjectName (const std::string &objectName)
| Set/get the name of this object for reporting purposes. More...
virtual std::string | GetObjectName () const
| Set/get the name of this object for reporting purposes. More...
Public Member Functions inherited from vtkObjectBase
const char * | GetClassName () const
| Return the class name as a string. More...
virtual vtkIdType | GetNumberOfGenerationsFromBase (const char *name)
| Given the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
virtual void | Delete ()
| Delete a VTK object. More...
virtual void | FastDelete ()
| Delete a reference to this object. More...
void | InitializeObjectBase ()
void | Print (ostream &os)
| Print an object to an ostream. More...
virtual void | Register (vtkObjectBase *o)
| Increase the reference count (mark as used by another object). More...
virtual void | UnRegister (vtkObjectBase *o)
| Decrease the reference count (release by another object). More...
int | GetReferenceCount ()
| Return the current reference count of this object. More...
void | SetReferenceCount (int)
| Sets the reference count. More...
bool | GetIsInMemkind () const
| A local state flag that remembers whether this object lives in the normal or extended memory space. More...
virtual void | PrintHeader (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...
virtual void | PrintTrailer (ostream &os, vtkIndent indent)
| Methods invoked by print to print information about the object including superclasses. More...

## Protected Member Functions
| vtkImageConvolve ()
| ~vtkImageConvolve () override
void | ThreadedRequestData (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector, vtkImageData ***inData, vtkImageData **outData, int outExt[6], int id) override
| If the subclass does not define an Execute method, then the task will be broken up, multiple threads will be spawned, and each thread will call this method. More...
void | GetKernel (double *kernel)
double * | GetKernel ()
void | SetKernel (const double *kernel, int sizeX, int sizeY, int sizeZ)
Protected Member Functions inherited from vtkThreadedImageAlgorithm
| vtkThreadedImageAlgorithm ()
| ~vtkThreadedImageAlgorithm () override
int | RequestData (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector) override
| This is called by the superclass. More...
virtual void | SMPRequestData (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector, vtkImageData ***inData, vtkImageData **outData, vtkIdType begin, vtkIdType end, vtkIdType pieces, int extent[6])
| Execute ThreadedRequestData for the given set of pieces. More...
virtual void | PrepareImageData (vtkInformationVector **inputVector, vtkInformationVector *outputVector, vtkImageData ***inDataObjects=nullptr, vtkImageData **outDataObjects=nullptr)
| Allocate space for output data and copy attributes from first input. More...
Protected Member Functions inherited from vtkImageAlgorithm
| vtkImageAlgorithm ()
| ~vtkImageAlgorithm () override
virtual int | RequestInformation (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector)
| Subclasses can reimplement this method to collect information from their inputs and set information for their outputs. More...
virtual int | RequestUpdateExtent (vtkInformation *, vtkInformationVector **, vtkInformationVector *)
| Subclasses can reimplement this method to translate the update extent requests from each output port into update extent requests for the input connections. More...
virtual void | CopyInputArrayAttributesToOutput (vtkInformation *request, vtkInformationVector **inputVector, vtkInformationVector *outputVector)
| Convenience method to copy the scalar type and number of components from the input data to the output data. More...
virtual void | ExecuteDataWithInformation (vtkDataObject *output, vtkInformation *outInfo)
| This is a convenience method that is implemented in many subclasses instead of RequestData. More...
virtual void | CopyAttributeData (vtkImageData *in, vtkImageData *out, vtkInformationVector **inputVector)
| Copy the other point and cell data. More...
virtual void | ExecuteData (vtkDataObject *output)
| This method is the old style execute method, provided for the sake of backwards compatibility with older filters and readers. More...
virtual void | Execute ()
| This method is the old style execute method, provided for the sake of backwards compatibility with older filters and readers. More...
virtual void | AllocateOutputData (vtkImageData *out, vtkInformation *outInfo, int *uExtent)
| Allocate the output data. More...
virtual vtkImageData * | AllocateOutputData (vtkDataObject *out, vtkInformation *outInfo)
| Allocate the output data. More...
int | FillOutputPortInformation (int port, vtkInformation *info) override
| These method should be reimplemented by subclasses that have more than a single input or single output. More...
int | FillInputPortInformation (int port, vtkInformation *info) override
| These method should be reimplemented by subclasses that have more than a single input or single output. More...
Protected Member Functions inherited from vtkAlgorithm
| vtkAlgorithm ()
| ~vtkAlgorithm () override
bool | CheckUpstreamAbort ()
| Checks to see if an upstream filter has been aborted. More...
virtual void | SetNumberOfInputPorts (int n)
| Set the number of input ports used by the algorithm. More...
virtual void | SetNumberOfOutputPorts (int n)
| Set the number of output ports provided by the algorithm. More...
int | InputPortIndexInRange (int index, const char *action)
int | OutputPortIndexInRange (int index, const char *action)
int | GetInputArrayAssociation (int idx, vtkInformationVector **inputVector)
| Get the association of the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkInformation * | GetInputArrayFieldInformation (int idx, vtkInformationVector **inputVector)
| This method takes in an index (as specified in SetInputArrayToProcess) and a pipeline information vector. More...
virtual vtkExecutive * | CreateDefaultExecutive ()
| Create a default executive. More...
void | ReportReferences (vtkGarbageCollector *) override
virtual void | SetNthInputConnection (int port, int index, vtkAlgorithmOutput *input)
| Replace the Nth connection on the given input port. More...
virtual void | SetNumberOfInputConnections (int port, int n)
| Set the number of input connections on the given input port. More...
void | SetInputDataInternal (int port, vtkDataObject *input)
| These methods are used by subclasses to implement methods to set data objects directly as input. More...
void | AddInputDataInternal (int port, vtkDataObject *input)
int | GetInputArrayAssociation (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
int | GetInputArrayAssociation (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkDataArray * | GetInputArrayToProcess (int idx, vtkDataObject *input, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkInformationVector **inputVector, int &association)
| Get the actual data array for the input array specified by idx, this is only reasonable during the REQUEST_DATA pass. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, int connection, vtkInformationVector **inputVector, int &association)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input)
| Filters that have multiple connections on one port can use this signature. More...
vtkAbstractArray * | GetInputAbstractArrayToProcess (int idx, vtkDataObject *input, int &association)
| Filters that have multiple connections on one port can use this signature. More...
virtual void | SetErrorCode (unsigned long)
| The error code contains a possible error that occurred while reading or writing the file. More...
Protected Member Functions inherited from vtkObject
| vtkObject ()
| ~vtkObject () override
void | RegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | UnRegisterInternal (vtkObjectBase *, vtkTypeBool check) override
void | InternalGrabFocus (vtkCommand *mouseEvents, vtkCommand *keypressEvents=nullptr)
| These methods allow a command to exclusively grab all events. More...
void | InternalReleaseFocus ()
| These methods allow a command to exclusively grab all events. More...
Protected Member Functions inherited from vtkObjectBase
| vtkObjectBase ()
virtual | ~vtkObjectBase ()
| vtkObjectBase (const vtkObjectBase &)
void | operator= (const vtkObjectBase &)

## Protected Attributes
int | KernelSize [3]
double | Kernel [343]
Protected Attributes inherited from vtkThreadedImageAlgorithm
vtkMultiThreader * | Threader
int | NumberOfThreads
bool | EnableSMP
int | SplitMode
int | SplitPath [3]
int | SplitPathLength
int | MinimumPieceSize [3]
vtkIdType | DesiredBytesPerPiece
Protected Attributes inherited from vtkAlgorithm
vtkTimeStamp | LastAbortCheckTime
vtkInformation * | Information
double | Progress
char * | ProgressText
vtkProgressObserver * | ProgressObserver
unsigned long | ErrorCode
| The error code contains a possible error that occurred while reading or writing the file. More...
Protected Attributes inherited from vtkObject
bool | Debug
vtkTimeStamp | MTime
vtkSubjectHelper * | SubjectHelper
std::string | ObjectName
Protected Attributes inherited from vtkObjectBase
std::atomic< int32_t > | ReferenceCount
vtkWeakPointerBase ** | WeakPointers
typedef vtkThreadedImageAlgorithm | Superclass
| Construct an instance of vtkImageConvolve filter. More...
static vtkImageConvolve * | New ()
| Construct an instance of vtkImageConvolve filter. More...
static vtkTypeBool | IsTypeOf (const char *type)
| Construct an instance of vtkImageConvolve filter. More...
static vtkImageConvolve * | SafeDownCast (vtkObjectBase *o)
| Construct an instance of vtkImageConvolve filter. More...
virtual vtkTypeBool | IsA (const char *type)
| Construct an instance of vtkImageConvolve filter. More...
vtkImageConvolve * | NewInstance () const
| Construct an instance of vtkImageConvolve filter. More...
void | PrintSelf (ostream &os, vtkIndent indent) override
| Construct an instance of vtkImageConvolve filter. More...
virtual vtkObjectBase * | NewInstanceInternal () const
| Construct an instance of vtkImageConvolve filter. More...

## Additional Inherited Members
Public Types inherited from vtkThreadedImageAlgorithm
typedef vtkImageAlgorithm | Superclass
Public Types inherited from vtkImageAlgorithm
typedef vtkAlgorithm | Superclass
Public Types inherited from vtkAlgorithm
enum | DesiredOutputPrecision { SINGLE_PRECISION , DOUBLE_PRECISION , DEFAULT_PRECISION }
| Values used for setting the desired output precision for various algorithms. More...
typedef vtkObject | Superclass
Static Public Member Functions inherited from vtkThreadedImageAlgorithm
static vtkTypeBool | IsTypeOf (const char *type)
static vtkThreadedImageAlgorithm * | SafeDownCast (vtkObjectBase *o)
static void | SetGlobalDefaultEnableSMP (bool enable)
| Global Disable SMP for all derived Imaging filters. More...
static bool | GetGlobalDefaultEnableSMP ()
| Global Disable SMP for all derived Imaging filters. More...
Static Public Member Functions inherited from vtkImageAlgorithm
static vtkTypeBool | IsTypeOf (const char *type)
static vtkImageAlgorithm * | SafeDownCast (vtkObjectBase *o)
Static Public Member Functions inherited from vtkAlgorithm
static vtkAlgorithm * | New ()
static vtkTypeBool | IsTypeOf (const char *type)
static vtkAlgorithm * | SafeDownCast (vtkObjectBase *o)
static vtkInformationIntegerKey * | INPUT_IS_OPTIONAL ()
| Keys used to specify input port requirements. More...
static vtkInformationIntegerKey * | INPUT_IS_REPEATABLE ()
static vtkInformationInformationVectorKey * | INPUT_REQUIRED_FIELDS ()
static vtkInformationStringVectorKey * | INPUT_REQUIRED_DATA_TYPE ()
static vtkInformationInformationVectorKey * | INPUT_ARRAYS_TO_PROCESS ()
static vtkInformationIntegerKey * | INPUT_PORT ()
static vtkInformationIntegerKey * | INPUT_CONNECTION ()
static vtkInformationIntegerKey * | CAN_PRODUCE_SUB_EXTENT ()
| This key tells the executive that a particular output port is capable of producing an arbitrary subextent of the whole extent. More...
static vtkInformationIntegerKey * | CAN_HANDLE_PIECE_REQUEST ()
| Key that tells the pipeline that a particular algorithm can or cannot handle piece request. More...
static vtkInformationIntegerKey * | ABORTED ()
static void | SetDefaultExecutivePrototype (vtkExecutive *proto)
| If the DefaultExecutivePrototype is set, a copy of it is created in CreateDefaultExecutive() using NewInstance(). More...
Static Public Member Functions inherited from vtkObject
static vtkObject * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | BreakOnError ()
| This method is called when vtkErrorMacro executes. More...
static void | SetGlobalWarningDisplay (vtkTypeBool val)
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOn ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static void | GlobalWarningDisplayOff ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
static vtkTypeBool | GetGlobalWarningDisplay ()
| This is a global flag that controls whether any debug, warning or error messages are displayed. More...
Static Public Member Functions inherited from vtkObjectBase
static vtkTypeBool | IsTypeOf (const char *name)
| Return 1 if this class type is the same type of (or a subclass of) the named class. More...
static vtkIdType | GetNumberOfGenerationsFromBaseType (const char *name)
| Given a the name of a base class of this class type, return the distance of inheritance between this class type and the named class (how many generations of inheritance are there between this class and the named class). More...
static vtkObjectBase * | New ()
| Create an object with Debug turned off, modified time initialized to zero, and reference counting on. More...
static void | SetMemkindDirectory (const char *directoryname)
| The name of a directory, ideally mounted -o dax, to memory map an extended memory space within. More...
static bool | GetUsingMemkind ()
| A global state flag that controls whether vtkObjects are constructed in the usual way (the default) or within the extended memory space. More...
Public Attributes inherited from vtkAlgorithm
std::atomic< vtkTypeBool > | AbortExecute
Protected Types inherited from vtkThreadedImageAlgorithm
enum | SplitModeEnum { SLAB = 0 , BEAM = 1 , BLOCK = 2 }
Static Protected Member Functions inherited from vtkAlgorithm
static vtkInformationIntegerKey * | PORT_REQUIREMENTS_FILLED ()
Static Protected Member Functions inherited from vtkObjectBase
static vtkMallocingFunction | GetCurrentMallocFunction ()
static vtkReallocingFunction | GetCurrentReallocFunction ()
static vtkFreeingFunction | GetCurrentFreeFunction ()
static vtkFreeingFunction | GetAlternateFreeFunction ()
Static Protected Attributes inherited from vtkThreadedImageAlgorithm
static bool | GlobalDefaultEnableSMP
Static Protected Attributes inherited from vtkAlgorithm
static vtkTimeStamp | LastAbortTime
static vtkExecutive * | DefaultExecutivePrototype

## Detailed Description

Convolution of an image with a kernel.

vtkImageConvolve convolves the image with a 3D NxNxN kernel or a 2D NxN kernel. The output image is cropped to the same size as the input.

Examples:
  vtkImageConvolve (Examples)

Online Examples:

Tests:
  vtkImageConvolve (Tests)

Definition at line 34 of file vtkImageConvolve.h.

## Member Typedef Documentation

## ◆ Superclass

typedef vtkThreadedImageAlgorithm vtkImageConvolve::Superclass

Construct an instance of vtkImageConvolve filter.

Definition at line 42 of file vtkImageConvolve.h.

## Constructor & Destructor Documentation

## ◆ vtkImageConvolve()

vtkImageConvolve::vtkImageConvolve | ( |  | ) |
| protected

## ◆ ~vtkImageConvolve()

vtkImageConvolve::~vtkImageConvolve | ( |  | ) |
| overrideprotected

## Member Function Documentation

## ◆ New()

static vtkImageConvolve* vtkImageConvolve::New | ( |  | ) |
| static

Construct an instance of vtkImageConvolve filter.

## ◆ IsTypeOf()

static vtkTypeBool vtkImageConvolve::IsTypeOf | ( | const char * | type | ) |
| static

Construct an instance of vtkImageConvolve filter.

## ◆ IsA()

virtual vtkTypeBool vtkImageConvolve::IsA | ( | const char * | type | ) |
| virtual

Construct an instance of vtkImageConvolve filter.

Reimplemented from vtkThreadedImageAlgorithm.

## ◆ SafeDownCast()

static vtkImageConvolve* vtkImageConvolve::SafeDownCast | ( | vtkObjectBase * | o | ) |
| static

Construct an instance of vtkImageConvolve filter.

## ◆ NewInstanceInternal()

virtual vtkObjectBase* vtkImageConvolve::NewInstanceInternal | ( |  | ) | const
| protectedvirtual

Construct an instance of vtkImageConvolve filter.

Reimplemented from vtkThreadedImageAlgorithm.

## ◆ NewInstance()

vtkImageConvolve* vtkImageConvolve::NewInstance | ( |  | ) | const

Construct an instance of vtkImageConvolve filter.

## ◆ PrintSelf()

void vtkImageConvolve::PrintSelf | ( | ostream & | os,
|  | vtkIndent | indent
| ) |  |
| overridevirtual

Construct an instance of vtkImageConvolve filter.

Reimplemented from vtkThreadedImageAlgorithm.

## ◆ GetKernelSize() [1/3]

virtual int* vtkImageConvolve::GetKernelSize | ( |  | ) |
| virtual

Get the kernel size.

## ◆ GetKernelSize() [2/3]

virtual void vtkImageConvolve::GetKernelSize | ( | int & | ,
|  | int & | ,
|  | int & |
| ) |  |
| virtual

Get the kernel size.

## ◆ GetKernelSize() [3/3]

virtual void vtkImageConvolve::GetKernelSize | ( | int | [3] | ) |
| virtual

Get the kernel size.

## ◆ SetKernel3x3()

void vtkImageConvolve::SetKernel3x3 | ( | const double | kernel[9] | ) |

Set the kernel to be a given 3x3 or 5x5 or 7x7 kernel.

## ◆ SetKernel5x5()

void vtkImageConvolve::SetKernel5x5 | ( | const double | kernel[25] | ) |

Set the kernel to be a given 3x3 or 5x5 or 7x7 kernel.

## ◆ SetKernel7x7()

void vtkImageConvolve::SetKernel7x7 | ( | const double | kernel[49] | ) |

## ◆ GetKernel3x3() [1/2]

double* vtkImageConvolve::GetKernel3x3 | ( |  | ) |

Return an array that contains the kernel.

## ◆ GetKernel3x3() [2/2]

void vtkImageConvolve::GetKernel3x3 | ( | double | kernel[9] | ) |

Return an array that contains the kernel.

## ◆ GetKernel5x5() [1/2]

double* vtkImageConvolve::GetKernel5x5 | ( |  | ) |

Return an array that contains the kernel.

## ◆ GetKernel5x5() [2/2]

void vtkImageConvolve::GetKernel5x5 | ( | double | kernel[25] | ) |

Return an array that contains the kernel.

## ◆ GetKernel7x7() [1/2]

double* vtkImageConvolve::GetKernel7x7 | ( |  | ) |

## ◆ GetKernel7x7() [2/2]

void vtkImageConvolve::GetKernel7x7 | ( | double | kernel[49] | ) |

## ◆ SetKernel3x3x3()

void vtkImageConvolve::SetKernel3x3x3 | ( | const double | kernel[27] | ) |

Set the kernel to be a 3x3x3 or 5x5x5 or 7x7x7 kernel.

## ◆ SetKernel5x5x5()

void vtkImageConvolve::SetKernel5x5x5 | ( | const double | kernel[125] | ) |

## ◆ SetKernel7x7x7()

void vtkImageConvolve::SetKernel7x7x7 | ( | const double | kernel[343] | ) |

## ◆ GetKernel3x3x3() [1/2]

double* vtkImageConvolve::GetKernel3x3x3 | ( |  | ) |

Return an array that contains the kernel.

## ◆ GetKernel3x3x3() [2/2]

void vtkImageConvolve::GetKernel3x3x3 | ( | double | kernel[27] | ) |

Return an array that contains the kernel.

## ◆ GetKernel5x5x5() [1/2]

double* vtkImageConvolve::GetKernel5x5x5 | ( |  | ) |

## ◆ GetKernel5x5x5() [2/2]

void vtkImageConvolve::GetKernel5x5x5 | ( | double | kernel[125] | ) |

## ◆ GetKernel7x7x7() [1/2]

double* vtkImageConvolve::GetKernel7x7x7 | ( |  | ) |

## ◆ GetKernel7x7x7() [2/2]

void vtkImageConvolve::GetKernel7x7x7 | ( | double | kernel[343] | ) |

## ◆ ThreadedRequestData()

void vtkImageConvolve::ThreadedRequestData | ( | vtkInformation * | request,
|  | vtkInformationVector ** | inputVector,
|  | vtkInformationVector * | outputVector,
|  | vtkImageData *** | inData,
|  | vtkImageData ** | outData,
|  | int | extent[6],
|  | int | threadId
| ) |  |
| overrideprotectedvirtual

If the subclass does not define an Execute method, then the task will be broken up, multiple threads will be spawned, and each thread will call this method.

It is public so that the thread functions can call this method.

Reimplemented from vtkThreadedImageAlgorithm.

## ◆ GetKernel() [1/2]

void vtkImageConvolve::GetKernel | ( | double * | kernel | ) |
| protected

## ◆ GetKernel() [2/2]

double* vtkImageConvolve::GetKernel | ( |  | ) |
| protected

## ◆ SetKernel()

void vtkImageConvolve::SetKernel | ( | const double * | kernel,
|  | int | sizeX,
|  | int | sizeY,
|  | int | sizeZ
| ) |  |
| protected

## Member Data Documentation

## ◆ KernelSize

int vtkImageConvolve::KernelSize[3]
| protected

Definition at line 109 of file vtkImageConvolve.h.

## ◆ Kernel

double vtkImageConvolve::Kernel[343]
| protected

Definition at line 110 of file vtkImageConvolve.h.

The documentation for this class was generated from the following file:

- Imaging/General/vtkImageConvolve.h